﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace XamGridObservableDictionary
{
    public partial class MainPage : UserControl
    {
        public ObservableDictionary<int, MyObject> data { get; set; }

        public MainPage()
        {
            InitializeComponent();
            data = new ObservableDictionary<int, MyObject>();
            data.Add(1, new MyObject() { Name = "Person1", Age = 10 });
            data.Add(2, new MyObject() { Name = "Person2", Age = 20 });
            data.Add(3, new MyObject() { Name = "Person3", Age = 30 });

            this.DataContext = data;
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            int index = data.Count + 1;

            data.Add(index, new MyObject() { Name = "Person" + index, Age = index * 10 });
        }

        private void button2_Click(object sender, RoutedEventArgs e)
        {
            data.Remove(data.LastOrDefault().Key);
        }

        private void button3_Click(object sender, RoutedEventArgs e)
        {
            foreach (var kvp in data)
            {
                kvp.Value.Age++;
            }
        }
    }

    public class MyObject : INotifyPropertyChanged
    {
        private int _Age;
        public int Age
        {
            get
            {
                return _Age;
            }

            set
            {
                _Age = value;

                this.OnPropertyChanged("Age");
            }
        }

        private string _Name;
        public string Name
        {
            get
            {
                return _Name;
            }

            set
            {
                _Name = value;

                this.OnPropertyChanged("Name");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        protected virtual void OnPropertyChanged(string propname)
        {
            if ((this.PropertyChanged != null))
            {
                this.PropertyChanged(this, new PropertyChangedEventArgs(propname));
            }
        }
    }
}
